;***************************************************************
; Modulname:    $Source: $
; User:         $Author: $
; Version:      $Name: $  $Revision: $
; Datum:        $Date: $
; Qualitt:     $State: $
;***************************************************************
; Beschreibung:
;
;*************************************************************** 
; Verwendete Register:
; R6,R7, A, B
;***************************************************************
; Funktionsaufruf in C51:
;  extern uint  ui_Hex2Bcd(uchar ucHex); // Wertig hex nach bcd
;  extern uchar uc_Bcd2Hex(uint uiBcd);  // Wertig dec nach hex
;***************************************************************
; Historie:
;==========
; $Log: $
;***************************************************************
; Definitionen
;***************************************************************
?PR?_ui_Hex2Bcd?HEX_BCD   SEGMENT CODE ; Code-Segment einrichten
?PR?_uc_Bcd2Hex?BCD_HEX   SEGMENT CODE ; Code-Segment einrichten

PUBLIC  _ui_Hex2Bcd                    ; 
PUBLIC  _uc_Bcd2Hex                    ; 

;***************************************************************
; HEX -> BCD Konvertierung 
; Version 1.1  Datum 28.09.98   User: MEBA
;***************************************************************

        RSEG  ?PR?_ui_Hex2Bcd?HEX_BCD  ; Codesegment setzen

_ui_Hex2Bcd:
        MOV    R6, #0
        MOV    A, R7
        MOV    B, #10
        DIV    AB
        CLR    C
KORREKTUR:
        SUBB   A, #10
      JC NO_OVERFLOW
        INC    R6
      SJMP KORREKTUR  
NO_OVERFLOW:
        ADD    A, #10
        SWAP   A
        ADD    A, B
        MOV    R7,A
      RET     

;***************************************************************
; HEX -> BCD Konvertierung 
; Version 1.1  Datum 28.09.98   User: MEBA
;***************************************************************
        RSEG  ?PR?_uc_Bcd2Hex?BCD_HEX ; Codesegment setzen
_uc_Bcd2Hex:
        MOV    A, R6
        MOV    B, #64H
        MUL    AB
        MOV    R6, A              ; Abspeicherung von 100 Werten
        MOV    A, R7              ; Zehner und Einer Berechnung
        SWAP   A
        MOV    B, #10
        ANL    A, #0FH
        MUL    AB
        ADD    A, R6
        XCH    A, R7
        ANL    A, #0FH
        ADD    A, R7
        MOV    R7, A  
      RET

      
END








